# Clean Feed
#  Version 0.95.2  1 January 1998
#
#  Spam filter for INN 1.5.1 and later
#   by Jeremy Nixon <jeremy@exit109.com>
#   originally based upon some code from Jeff Garzik
#
#  Install this file as filter_innd.pl, wherever your server expects
#  to find that file (possibly /usr/news/bin/control).
#  
#  Always check with "perl -cw" after making changes to this file
#  There should be no warnings

# Configuration:

$maxgroups = 14;		# maximum number of groups in a crosspost
$maxfollowups = 7;		# followups less than this is ok
$md5maxmultiposts = 5;		# start rejecting after this many copies
$maxmultiposts = 20;		# max for posting-host and from/subj/lines filters
$tjfmaxgroups = 6;		# max xposts in test, forsale, jobs groups
$ArticleHistory = 5000;		# keep history of last N article header sets
$MD5History = 10000;		# keep history of last N MD5 checksums
$EMPmaxlife = 24;		# time to keep EMP ids with no hits, in hours
$MD5maxlife = 24;		# same, for md5 ids
$EMPHistSize = 500;		# max number of EMP ids to ever hold in memory
$MD5HistSize = 4500;		# same, for md5 ids
$EMPstarttrimming = 500;	# do not waste time trimming until this many entries
$trimcycles = 450;		# trim hashes every N cycles through filter
$MIDmaxlife = 1;		# time to keep rejected message-ids, in hours

$verbose = 1;			# stick lots of cool stuff into news.notice?
$block_binaries = 1;		# set to 1 to block misplaced binaries
$max_encoded_lines = 15;	# number of encoded binary lines to allow
$block_mime_html = 1;           # set to 1 to block MIME encapsulated HTML
                                #  (NOT straight or multipart/alternative)
$block_html = 0;		# set to 1 to block HTML and multipart/alternative
$block_late_cancels = 0;	# set to 1 to block cancels of rejected articles

$statfile = undef;		# full path of file for crude stats

	# binaries allowed if groups match
$bin_allowed = '\.binae?r(?:ies)?|alt\.sex\.pictures|alt\.anonymous\.messages'.
    '|de\.alt\.dateien';
	# md5 EMP check not done if groups match
$md5exclude = '\.test';
	# no checks done if groups match
$allexclude = '^clari\.';

# this should probably be commented out if you aren't using MD5
my $md5;
eval {require MD5; $md5 = new MD5};

# reject messages with these domain names in URL, From, or posting-host
$badguys = 'eroticboxoffice|sweet18|kissingirls|erosnet|shockingpink|dominationx'.
    '|xbo|pussyforyourface|itouchmyself|beverlyhills-hookers|libidox'.
    '|cherrypoppers|freesex|backdoor|(?:\w+\.)?barditt?ch|\w+\.quim'.
    '|velocity|holowww|\w+\.holowww|sensuality|slutboys|peepingtoms'.
    '|gigapix|6t9|nudesights|porngodess|phatt|rawxxxfun|porn-?king|hardsexjunkies'.
    '|pervert|free-pics|dreamlands|youwish|ilovecelebs|dirtysecrets'.
    '|earthcalls|debutantes|answerme|emi|theaterx|nudelynx|babesofage'.
    '|wildchild|ilovelez|sexjunky|nymphette|stobblehouse|hard-core'.
    '|latexfetish|harddicks|\w+\.mnet1|pictureview|lasersex|sexypussy'.
    '|lick|orgasmic|malebytes|southcorp|mansclub|inet-images|pornschool'.
    '|hotsexnow|bmc-engineering|nastygirlz|marys-place|ucla\.dorms|savetrees'.
    '|(?:\w+\.)sexzilla|netzilla|jalapeno|orchidvideos|blowme|totallyfreesex'.
    '|sexplosion|unitedadultsites|rsi-net|cathouse|forbiddenphotos'.
    '|amateur-xposure|teencity|snmworld|spck';

$baddomainpat = '\w+xxx|xxx\w+';

$badips = '207\.70\.214\.|208\.208\.223\.'.
    '|207\.156\.223\.|205\.147\.202\.|206\.161\.233\.228|208\.214\.26\.231';

$exempt = 'news\.aol\.com|news\.newsdawg\.com|webtv\.net|newscene\.newscene\.com'.
    '|hme1-1\.news\.sprint\.ca|news1\.mcps\.com|^localhost$';

$tlds = 'com|net|org|edu|nl|de|no|dk|ch|com\.au|se';	# top-level domains
$ip = '\d{2,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b';	# match an ip address
	# $url matches a URL, $url2 is same but requires http://
$url = '(?:[Hh][Tt][Tt][Pp]:\/\/?|[Ww]{3})(?:[\w\-\.]+\.' . "$tlds|$ip" . ')\b';
$url2 = '[Hh][Tt][Tt][Pp]:\/\/?(?:[\w\-\.]+\.' . "$tlds|$ip" . ')\b';

$ci_begin = '[Bb][Ee][Gg][Ii][Nn]';	# faster at this length than /i
$ci_ctype = '[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]';
$ci_cte = '[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Rr][Aa][Nn][Ss][Ff][Ee][Rr]-[Ee][Nn][Cc][Oo][Dd][Ii][Nn][Gg]';
$ci_txht = '(?:[Tt][Ee]?[Xx][Tt]|[Hh][Tt][Mm][Ll]?|[Uu][Rr][Ll])';
$ci_html = '[Tt][Ee][Xx][Tt]\/[Hh][Tt][Mm][Ll]';

$base64_chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789\+\/';
$uu_chars = q| `!"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_|;
$uu_chars =~ s/(\W)/\\$1/g;

$sex = 'sex|xxx|fuck';
$servPre = '(?:free|cheap|unlimited|nationwide|hard.?core)';
$servPost = '(?:free|minute|samples|800|900)';
$servStr = "(?:phone.{0,15}(?:$sex)|(?:adult|$sex).{0,10}(?:chat|site)".
    "|(?:$sex).{0,15}(?:shows|calls|connections|pi(?:cs|x|ctures))".
    "|hardcore video|900 dateline|mass e?-?mail)";
$services = "(?:$servPre.{0,30}?$servStr)|(?:$servStr.{0,30}?$servPost)";

$EMPmaxlife = $EMPmaxlife * 3600;	# convert to seconds
$MD5maxlife = $MD5maxlife * 3600;
$MIDmaxlife = $MIDmaxlife * 3600;

&writestats;	# write stat file on each reload (if $statfile is defined)

sub filter_art {

    if (! $hdr{"Control"}) {
	return "" if ($hdr{"Newsgroups"} =~ /$allexclude/o);	# needs to be better
	&trimhashes if ($cycles++ > $trimcycles);
	$now = time;			# time is used in several places

	if (defined $md5) {
	    undef $md5hash;
	    if ((! $hdr{"References"}) && ($hdr{"Newsgroups"} !~ /$md5exclude/o)) {
		$md5hash = $md5->hexhash($hdr{"__BODY__"});
	    }
	    if ($md5EMP{$md5hash}) {
		$md5EMP{$md5hash} = $now;
		return reject ("EMP rejected" . ($verbose ? " (md5)" : ""));
	    }
	}

	if ($hdr{"Sender"}) {
	    $hash1 = lc("$hdr{'Sender'} $hdr{'Subject'} $hdr{'Lines'}");
	} else {
	    $hash1 = lc("$hdr{'From'} $hdr{'Subject'} $hdr{'Lines'}");
	}
	undef $hash2;
	unless ($hdr{"NNTP-Posting-Host"} =~ /(?:$exempt)/o ||
		($hdr{"Newsgroups"} =~ /$bin_allowed/o && $hdr{"Lines"} > 999)) {
	    $hash2 = "$hdr{'NNTP-Posting-Host'} $hdr{'Lines'}" if ($hdr{'NNTP-Posting-Host'});
	}

	if ($EMP{$hash2}) {
	    $EMP{$hash2} = $now;
	    return reject ("EMP rejected" . ($verbose ? " (ph/l)" : ""));
	} elsif ($EMP{$hash1}) {
	    $EMP{$hash1} = $now;
	    return reject ("EMP rejected" . ($verbose ? " (f/s/l)" : ""));
	}

	($hdr{"Newsgroups"} =~ /(?:,+[^,]+){$maxgroups,}?/o) &&
	    ((! $hdr{"Followup-To"}) ||
	     ($hdr{"Followup-To"} =~ /(?:,+[^,]+){$maxfollowups,}?/o)) &&
	     (return reject ("Too many newsgroups"));

	($hdr{"Newsgroups"} =~ /alt\.binaires/) &&
	    (return reject ("Misspelling trap"));

	($hdr{"Newsgroups"} =~ /(?:[^,]+\.(test|jobs|forsale)[^,]*,){$tjfmaxgroups,}?/o) &&
	    (return reject ($verbose ? "$1 group: too many crossposts" : "Too many newsgroups"));

	if ($hdr{"Newsgroups"} !~ /news\.admin\.net-abuse/) {

	    my ($organization) = lc($hdr{"Organization"});

	    (($hdr{"Path"} =~ /news\.florida-isp\.com!/) ||
	     ($hdr{"NNTP-Posting-Host"} =~ /(?:florida-isp|escortguide|metrosupport)\.com/)) &&
		(return reject ($verbose ? "Spam - florida-isp.com" : "Spam domain"));

	    ($organization =~ /adult\s+internet\s+access/) &&
		(return reject ($verbose ? "Spam - Adult Internet Access" : "Spam domain"));

	    ($organization =~ /email\s+platinum/) &&
		(return reject ($verbose ? "Email Platinum" : "Bot signature"));

	    ($hdr{"From"} =~ /($url2)/o) &&
		(return reject ("URL in From" . ($verbose ? " - $1" : "")));

	    (($organization =~ /((?:\b$badguys|$baddomainpat)\.(?:$tlds)\b|$badips)/o) ||
	     (lc($hdr{"From"}) =~ /(\b(?:$badguys)\.(?:$tlds)\b|$badips)/o) ||
	     (lc($hdr{"NNTP-Posting-Host"}) =~ /(\b(?:$badguys)\.(?:$tlds)\b)/o)) &&
		 (return reject ($verbose ? "Spam - $1" : "Spam domain"));

	    (($organization =~ /(?:net|sex)zilla\.(?:net|com)|repost.*unauthorized.*cancel|newsfeeds\.com/) ||
	     ($hdr{"Message-ID"} =~ /netzilla\.net|sexzilla\.com|207\.70\.214\.|newsfeeds\.com|metro\.goldw?yy?n\.au/) ||
	     ($hdr{"Path"} =~ /newsfeeds\.com|news\.jamm?\.com|metro\.goldwyyn\.au|bcarh8c.bnr.ca!news.primenet.com/)) &&
		 (return reject ($verbose ? "Spam - Netzilla" : "Spam domain"));

	    if (! $hdr{"References"}) {

		($hdr{"Organization"} =~ /^[A-Z]{2,3}\sInc\.\s*$/) &&
		    ($hdr{"Message-ID"} =~ /<\d{12}\.\d{10}\@/) &&
		    (return reject ($verbose ? "Adultsights bot" : "Bot signature"));

		($hdr{"Message-ID"} =~ /msgidabcxyz\.com/) &&
		    (return reject ($verbose ? "Bot - msgidabcxyz" : "Bot signature"));

		if (($hdr{"Newsgroups"} !~ /news\.lists\.filters|alt\.nocem\.misc|fr\.usenet\.abus\.rapports/) &&
		    ($hdr{"From"} !~ /nl-cancel\@.*xs4all\.nl|lendl\@.*sbg\.ac\.at|lendl\@eddie\.ping\.at/)) {

		    (lc($hdr{"Subject"}) =~ /($services)/o) &&
			($md5hash ? md5savehist ($md5hash) : 1) &&
			(return reject ("Services spam" . ($verbose ? " - $1" : "")));
		}
	    } # references
        } # news.admin.net-abuse.*

        if ($hdr{"Newsgroups"} !~ /news\.lists\.filters|alt\.nocem\.misc|news\.admin\.net-abuse\.bulletins/) {

	    $empreturn = "";

	    # store From, Subject, and Lines in history array and hash
	    push @history, $hash1;
	    $history{$hash1}++;
	    # Store NNTP-Posting-Host and Lines
	    if ($hash2) {
		push @history, $hash2;
		$history{$hash2}++;
	    }
            # MD5 checksums
	    if ($md5hash) {
		push @md5history, $md5hash;
		$md5history{$md5hash}++;
	    }

	    # if post appears more than high limit, save for
	    # continual rejection, outside of history window
	    if (($md5hash) and ($md5history{$md5hash} > $md5maxmultiposts)) {
	        md5savehist ($md5hash);
	        $empreturn = "New EMP detected (md5)";
	    } elsif (($hash2) and ($history{$hash2} > $maxmultiposts)) {
		savehist ($hash2);
		$empreturn = "New EMP detected (ph/l)";
	    } elsif ($history{$hash1} > $maxmultiposts) {
		savehist ($hash1);
		$empreturn = "New EMP detected (f/s/l)";
	    }

	    # trim old entries from history.
	    # the data structure stays around, even between filter.perl reloads.
	    while ($#history > $ArticleHistory) {
		$tmp_hist = shift @history;
		next unless (exists $history{$tmp_hist});
		delete $history{$tmp_hist} if ($history{$tmp_hist}-- < 2);
	    }
	    while ($#md5history > $MD5History) {
		$tmp_hist = shift @md5history;
		next unless (exists $md5history{$tmp_hist});
		delete $md5history{$tmp_hist} if ($md5history{$tmp_hist}-- < 2);
	    }

	    return reject ($empreturn) unless ($empreturn eq "");
	} # news.lists.filters/alt.nocem.misc/nana.bulletins

	# now the expensive ones, moved to the end for performance

	# uuencoded html, text, url files
	($hdr{"Lines"} > 3) &&
	    ($hdr{"__BODY__"} =~ /^$ci_begin\s+[0-7]{3,4}\s+\S?.{0,45}?\S+\.(${ci_txht})\n+(?:^[\s|>]*M[$uu_chars]{60,61}\s*\n){2,}?/mo) &&
	    (return reject ("UUencoded $1"));

	# binaries in non-binary newsgroups
	if ($block_binaries) {
	    if ($hdr{"Lines"} > $max_encoded_lines) {
		@gr = split /[, ]+/, $hdr{"Newsgroups"};
		if (grep !/$bin_allowed/o, @gr) {
		    (($hdr{"__BODY__"} =~ /(?:^[\s>]*[$base64_chars]{59,76}\s*\n){$max_encoded_lines,}?/mo) ||
		     ($hdr{"__BODY__"} =~ /(?:^[\s>]*M[$uu_chars]{60,61}\s*\n){$max_encoded_lines,}?/mo)) &&
			 (return reject ("Binary in non-binary group"));
		}
	    }
	}

	# mime-encapsulated HTML
        if ($block_mime_html) {
	    (($hdr{"Content-Disposition"} =~ /filename.*\.html?/) ||
	     ($hdr{"Content-Base"} =~ /file:.*\.html?/) ||
	     ((lc($hdr{"Content-Type"}) =~ /multipart\/mixed/) &&
	      ($hdr{"Newsgroups"} =~ /$bin_allowed/o) &&
	      ($hdr{"__BODY__"} =~ /^$ci_ctype:\s+text\/html/mo) &&
	      ($hdr{"__BODY__"} =~ /^$ci_cte:\s[Bb][Aa][Ss][Ee]64/mo))) &&
		  (return reject ("Misc HTML spam"));
	}

	# HTML (and multipart/alternative)
	if ($block_html) {
	    (lc($hdr{"Content-Type"}) =~ /text\/html|multipart\/alternative/) &&
		(return reject ("HTML post"));
	    (lc($hdr{"Content-Type"}) =~ /multipart\/mixed/) &&
		($hdr{"__BODY__"} =~ /^$ci_ctype:\s$ci_html/) &&
		(return reject ("HTML post"));
	}

        if (($hdr{"Newsgroups"} !~ /news\.admin\.net-abuse|news\.lists\.filters|alt\.nocem\.misc|fr\.usenet\.abus\.rapports/) &&
	    ($hdr{"From"} !~ /nl-cancel\@.*xs4all\.nl|lendl\@.*sbg\.ac\.at|lendl\@eddie\.ping\.at/)) {

	    if (! $hdr{"References"}) {

		($hdr{"__BODY__"} =~ /\.*[\r<=>]+\r[\r<=>]+$/m) &&
		    (return reject ($verbose ? "Angle-bracket bot" : "Bot signature"));

		($hdr{"Lines"} < 3) &&
		    ($hdr{"__BODY__"} =~ /^\s*($url)\s*$/o) &&
		    (return reject ("Only URL" . ($verbose ? " - $1" : "")));

		my ($body) = lc(substr($hdr{"__BODY__"},0,50000));
		($body =~ /http:..((?:www\.)?(?:$badguys|$baddomainpat)\.(?:$tlds)|$badips)/o) &&
		    (return reject ($verbose ? "Spam - $1" : "Spam domain"));

		(($body =~ /(?:(?:over\s+18|adults?)\s+only|must\s+be\s+(?:at\s+least\s+)?18[.,\s]|calls?\s+billed\s+as\s+long\s+distance)/) &&
                     ($body =~ /\b(1[- ]*(?:[89]00|888)[- ]+\d{3}[- ]+\d{4})\b/)) &&
		     (return reject ("Phone sex spam" . ($verbose ? " - $1" : " (1-800/1-900)")));

	    }
	}

        return "";	# Article Okay!

    } elsif ($hdr{"Control"} =~ /cancel/) {

	if ($block_late_cancels) {
	    if ($hdr{"Control"} =~ /^cancel (.*)$/) {
		$canmid = $1;
		return "Cancel for rejected article" if (exists $MIDhistory{$canmid});
	    }
	}

	($hdr{"__BODY__"} =~ /Usenet.*Cancel.*Engine/ms) &&
	    (return "Rogue cancel" . ($verbose ? " (UCE)" : ""));

	($hdr{"Newsgroups"} =~ /control\.cancel/) &&
	    (return "Rogue cancel" . ($verbose ? " (newsgroups)" : ""));

	($hdr{"Path"} =~ /((?:hacker|crack|porn|cripple|gimp|cunt|hole|fag|aids|faq|god|hindu|dothead|jew|kike|moslem|towelhead|nazi|kraut|nerd|geek|nigger|redneck|rice|slanteye|spick|whine)cancel|cyberwhin(?:er|ing))/) &&
	    (return "Rogue cancel" . ($verbose ? " - $1" : ""));

    } elsif ($hdr{"Control"} =~ /(?:new|rm)group\s(?:comp|misc|news|rec|soc|sci|humanities|talk)/) {

	    ($hdr{"From"} !~ /group-admin\@isc\.org/) &&
	    (return $verbose ? "Big 8 control message from wrong address" : "Bad control message");

    } elsif ($hdr{"Control"} =~ /(?:new|rm)group\s/) {

	    ($hdr{"__BODY__"} =~ /Control message generated by Netscape Collabra Server/) &&
		(return $verbose ? "Bogus control message from Collabra luser" : "Bad control message");

	    (($hdr{"From"} =~ /sexzilla\.com|netzilla\.net/) ||
	     ($hdr{"Control"} =~ /newgroup.*(?:sexzilla|netzilla)/)) &&
		 (return $verbose ? "Sexzilla newgroup message" : "Bad control message");
    }
    return "";
}

sub trimhashes {
    my ($id,$lasthit,$over,$when);

    # trim too-old entries from %EMP
    if (scalar keys %EMP > $EMPstarttrimming) {
        while (($id,$lasthit) = each %EMP) {
            delete $EMP{$id} if (($now - $lasthit) > $EMPmaxlife);
        }
        # if still over the max, delete oldest entries until it's small enough
        $over = (scalar keys %EMP) - $EMPHistSize;
        if ($over > 0) {
            foreach $id (sort { $EMP{$b} <=> $EMP{$a} } keys %EMP) {
                delete $EMP{$id};
                last if (--$over < 1);
            }
        }
    }
    # trim too-old entries from %md5EMP
    if (scalar keys %md5EMP > $EMPstarttrimming) {
        while (($id,$lasthit) = each %md5EMP) {
            delete $md5EMP{$id} if (($now - $lasthit) > $MD5maxlife);
        }
        # if still over the max, delete oldest entries until it's small enough
        $over = (scalar keys %md5EMP) - $MD5HistSize;
        if ($over > 0) {
            foreach $id (sort { $md5EMP{$b} <=> $md5EMP{$a} } keys %md5EMP) {
                delete $md5EMP{$id};
                last if (--$over < -50);	# cut into it so we don't have to come back soon
            }
        }
    }
    # trim too-old entries from %MIDhistory
    while (($id,$when) = each %MIDhistory) {
	delete $MIDhistory{$id} if (($now - $when) > $MIDmaxlife);
    }

    $cycles = 0;	# start the counter over
} 

sub savehist {
    # store the EMP id in %EMP
    my ($key) = @_;

    $EMP{$key} = $now;
    delete $history{$key} if (exists $history{$key});
    @history = grep (!($_ eq $key), @history);
    return 1;
}

sub md5savehist {
    # store the MD5 EMP id in %md5EMP
    my ($key) = @_;

    $md5EMP{$key} = $now;
    delete $history{$key} if (exists $history{$key});
    @history = grep (!($_ eq $key), @history);
    return 1;
}

sub reject {
    # called to reject a post so we can catch the message-id
    # pass text for rejection, returns same text
    my ($text) = @_;

    if ($block_late_cancels) {
	$MIDhistory{"$hdr{'Message-ID'}"} = $now;
    }
    return $text;
}

sub filter_mode {
    return;
}

sub writestats {
    # write a crude stat file so we can see what the hashes are doing
    # this will grow in the future

    return 1 unless (defined $statfile);

    my ($emphashentries) = scalar keys %EMP;
    my ($md5hashentries) = scalar keys %md5EMP;
    my ($midhistentries) = scalar keys %MIDhistory;

    open FILE, ">$statfile" or return 0;
    print FILE "MD5 entries: $md5hashentries\n";
    print FILE "EMP entries: $emphashentries\n";
    print FILE "MID history: $midhistentries\n";

    close FILE;
}
